org.apache.hc.core5.http2.ssl

## Class ConscryptClientTlsStrategy

- java.lang.Object
- - org.apache.hc.core5.http2.ssl.ConscryptClientTlsStrategy

- All Implemented Interfaces:
    TlsStrategy

      public class ConscryptClientTlsStrategy
      extends Object
      implements TlsStrategy

  Basic client-side implementation of `TlsStrategy` that upgrades to TLS for all endpoints with `HTTPS` scheme.
  Since:
    5.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ConscryptClientTlsStrategy()` Empty constructor with the default SSL context based on system properties.
    `ConscryptClientTlsStrategy(SSLContext sslContext)`
    `ConscryptClientTlsStrategy(SSLContext sslContext, SSLBufferMode sslBufferMode, SSLSessionInitializer initializer, SSLSessionVerifier verifier)`
    `ConscryptClientTlsStrategy(SSLContext sslContext, SSLSessionInitializer initializer, SSLSessionVerifier verifier)`
    `ConscryptClientTlsStrategy(SSLContext sslContext, SSLSessionVerifier verifier)`
    `ConscryptClientTlsStrategy(SSLSessionVerifier verifier)` Constructor with the default SSL context based on system properties and custom `SSLSessionVerifier` verifier.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `upgrade(TransportSecurityLayer tlsSession, HttpHost host, SocketAddress localAddress, SocketAddress remoteAddress, Object attachment, Timeout handshakeTimeout)` Deprecated. use `upgrade(TransportSecurityLayer, NamedEndpoint, Object, Timeout, FutureCallback)`
    `void` | `upgrade(TransportSecurityLayer tlsSession, NamedEndpoint endpoint, Object attachment, Timeout handshakeTimeout, FutureCallback<TransportSecurityLayer> callback)` Secures current session layer with TLS.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ConscryptClientTlsStrategy

          public ConscryptClientTlsStrategy(SSLContext sslContext,
                                            SSLBufferMode sslBufferMode,
                                            SSLSessionInitializer initializer,
                                            SSLSessionVerifier verifier)

    - #### ConscryptClientTlsStrategy

          public ConscryptClientTlsStrategy(SSLContext sslContext,
                                            SSLSessionInitializer initializer,
                                            SSLSessionVerifier verifier)

    - #### ConscryptClientTlsStrategy

          public ConscryptClientTlsStrategy(SSLContext sslContext,
                                            SSLSessionVerifier verifier)

    - #### ConscryptClientTlsStrategy

          public ConscryptClientTlsStrategy(SSLContext sslContext)

    - #### ConscryptClientTlsStrategy

          public ConscryptClientTlsStrategy()

      Empty constructor with the default SSL context based on system properties.
      Since:
        5.2
      See Also:
        `SSLContext`

    - #### ConscryptClientTlsStrategy

          public ConscryptClientTlsStrategy(SSLSessionVerifier verifier)

      Constructor with the default SSL context based on system properties and custom `SSLSessionVerifier` verifier.
      Parameters:
        `verifier` - the custom `SSLSessionVerifier`.
      Since:
        5.2

  - ### Method Detail

    - #### upgrade

          public void upgrade(TransportSecurityLayer tlsSession,
                              NamedEndpoint endpoint,
                              Object attachment,
                              Timeout handshakeTimeout,
                              FutureCallback<TransportSecurityLayer> callback)

      Description copied from interface: `TlsStrategy`
      Secures current session layer with TLS.
      Specified by:
        `upgrade` in interface `TlsStrategy`
      Parameters:
        `tlsSession` - the session layer
        `endpoint` - the name of the opposite endpoint when applicable or `null` otherwise.
        `attachment` - arbitrary object passes to the TLS session initialization code.
        `handshakeTimeout` - the timeout to use while performing the TLS handshake; may be `null`.
        `callback` - Operation result callback.

    - #### upgrade

          @Deprecated
          public boolean upgrade(TransportSecurityLayer tlsSession,
                                             HttpHost host,
                                             SocketAddress localAddress,
                                             SocketAddress remoteAddress,
                                             Object attachment,
                                             Timeout handshakeTimeout)

      Deprecated. use `upgrade(TransportSecurityLayer, NamedEndpoint, Object, Timeout, FutureCallback)`
      Description copied from interface: `TlsStrategy`
      Secures current session layer with TLS.
      Specified by:
        `upgrade` in interface `TlsStrategy`
      Parameters:
        `tlsSession` - the session layer
        `host` - the name of the opposite endpoint when given or `null` otherwise.
        `localAddress` - the address of the local endpoint.
        `remoteAddress` - the address of the remote endpoint.
        `attachment` - arbitrary object passes to the TLS session initialization code.
        `handshakeTimeout` - the timeout to use while performing the TLS handshake; may be `null`.
      Returns:
        `true` if the session has been upgraded, `false` otherwise.

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.